// ////////////////////////////////////////////////////
//
// StdView.cpp : implementation of the CStdView class
// Based on class COGLView : public CView
// Inspect COGLView for standard OpenGL initialization
//
////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Std.h"
#include "math.h"
#include "StdDoc.h"
#include "StdView.h"
#include "guests.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////
// You can put definitions, variables and helperfunctions
// here. Functions that does not rely on CStdView member
// variables or functions
// for picking
#define BUFSIZE 256
// flag no hit 
#define NOHIT 999

//////////////////////////////////////////////////////////
// CStdView

IMPLEMENT_DYNCREATE(CStdView, COGLView)

BEGIN_MESSAGE_MAP(CStdView, COGLView)
	//{{AFX_MSG_MAP(CStdView)
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDBLCLK()
	ON_COMMAND(ID_HANDLING_INSPISER, OnHandlingInspiser)
	ON_COMMAND(ID_HANDLING_LEGGDUK, OnHandlingLeggduk)
	ON_WM_TIMER()
	ON_COMMAND(ID_HANDLING_TAKLYS, OnHandlingTaklys)
	ON_UPDATE_COMMAND_UI(ID_HANDLING_TAKLYS, OnUpdateHandlingTaklys)
	ON_COMMAND(ID_HANDLING_LYS1, OnHandlingLys1)
	ON_COMMAND(ID_HANDLING_LYS2, OnHandlingLys2)
	ON_UPDATE_COMMAND_UI(ID_HANDLING_LYS1, OnUpdateHandlingLys1)
	ON_UPDATE_COMMAND_UI(ID_HANDLING_LYS2, OnUpdateHandlingLys2)
	ON_COMMAND(ID_HANDLING_GJESTER, OnHandlingGjester)
	ON_WM_RBUTTONDOWN()
	ON_COMMAND(ID_HANDLING_SETHOME, OnHandlingSethome)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

///////////////////////////////////////////////////////////
// CStdView construction/destruction

CStdView::CStdView()
{
	m_Vz=0.0f;
	m_Vx=0.0f;
	m_Vy=0.0f;
	ex=80.0f;
	ey=80.0f;
	ez=20.0f;
	guests=4;
	isWalking=FALSE;
	m_DrawMode=GL_RENDER;
	m_hRC=NULL;
	m_hDC=NULL;
};

CStdView::~CStdView()
{}

////////////////////////////////////////////////////////////
// CStdView diagnostics
// You should usually not touch these:
#ifdef _DEBUG
void CStdView::AssertValid() const
{COGLView::AssertValid();}
void CStdView::Dump(CDumpContext& dc) const
{COGLView::Dump(dc);}

CStdDoc* CStdView::GetDocument() // non-debug version is inline
{	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CStdDoc)));
	return (CStdDoc*)m_pDocument;
}
#endif //_DEBUG

//////////////////////////////////////////////////////////////
// CStdView operations

void CStdView::DrawScene()
{
	// Clear the color and depth buffers.
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		
	// Set up for scene
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(	ex,ey,ez,
				0.0f,0.0f,0.0f,
				0.0f,0.0f,1.0f);
	// take it down z a little bit
	glTranslatef(0.0f,0.0f,-10.0f);
	// tilt it around x
	glRotatef(m_Vx,1.0f,0.0f,0.0f);
	// tilt it around y
	glRotatef(m_Vy,0.0f,1.0f,0.0f);

	// the action

	glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,1);

	Table.SetDisplayMode(m_DrawMode);
	Table.Bord(50.0f,guests);
	
	glFlush();
}

void CStdView::InitializeRContext()
{
	// here we set the attributes that will be constant
	// during the windows lifetime
	// must be adjusted
    GLfloat ambient[] =		{ 0.2f, 0.2f, 0.2f, 1.0f };
    GLfloat ambientx[] =	{ 0.0f, 0.0f, 0.0f, 1.0f };
	GLfloat diffuse[] =		{ 1.0f, 1.0f, 1.0f, 1.0f };
    GLfloat diffuse1[] =	{ 0.5f, 0.5f, 0.5f, 1.0f };
    GLfloat diffuse2[] =	{ 0.5f, 0.5f, 0.5f, 1.0f };
    GLfloat position[] =	{ 200.0f, 300.0f, 100.0f, 0.0f };
    GLfloat lmodel_ambient[] = { 0.4f, 0.4f, 0.4f, 1.0f };
    GLfloat local_view[] = { 0.0f };

    glEnable(GL_DEPTH_TEST);
    glDepthFunc(GL_LESS);

    glLightfv(GL_LIGHT0, GL_AMBIENT, ambient);
    glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuse);
    glLightfv(GL_LIGHT0, GL_POSITION, position);

    glLightfv(GL_LIGHT1, GL_AMBIENT, ambientx);
    glLightfv(GL_LIGHT1, GL_DIFFUSE, diffuse1);

    glLightfv(GL_LIGHT2, GL_AMBIENT, ambientx);
    glLightfv(GL_LIGHT2, GL_DIFFUSE, diffuse2);

    glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lmodel_ambient);
 
    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);
    glEnable(GL_LIGHT1);
    glEnable(GL_LIGHT2);
	
	glEnable(GL_NORMALIZE);
	glShadeModel(GL_SMOOTH);

    glClearColor(0.0f, 0.0f, 0.4f, 0.0f);
}

void CStdView::SetPerspective(int cx, int cy)
{
    glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(70.0f, (GLdouble)cx/cy, 0.1f, 200.0f);
    glMatrixMode(GL_MODELVIEW);
}


void CStdView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// user has pressed left button.
	// make a note of this and prpare for intuitive rotation
	m_PStart=point;
	m_PLast=point;
	SetCapture();
	CView::OnLButtonDown(nFlags, point);
}

void CStdView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// if left button is down 
	if(nFlags && MK_LBUTTON)
	{	
		// and has moved a significant dist
		if((abs(m_PLast.x-point.x)>0)&&(abs(m_PLast.y-point.y)>0))
		{
			// we find an intuitive rot angle
			CRect R;
			GetClientRect(&R);
			
			m_Vx+=90.0f*((GLfloat (point.x-m_PLast.x))/GLfloat (R.Width()));
			m_Vy+=90.0f*((GLfloat (point.y-m_PLast.y))/GLfloat (R.Height()));
			// and force redraw 
			m_PLast=point;
			RedrawWindow();
		}
	}
}

void CStdView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// free capture and redraw
	ReleaseCapture();
	CView::OnLButtonUp(nFlags, point);
}

void CStdView::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	m_Vz=0.0f;
	m_Vx=0.0f;
	m_Vy=0.0f;
	RedrawWindow();
	CView::OnLButtonDblClk(nFlags, point);
}

void CStdView::OnHandlingInspiser() 
{
	// start walk around table
	if(!isWalking)
	{
		isWalking=TRUE;
		wv=0.0f;
		SetTimer(1,100,NULL);
	}
	else
		isWalking=FALSE;
}

void CStdView::OnHandlingLeggduk() 
{
	// TODO: Add your command handler code here
	
}

void CStdView::OnTimer(UINT nIDEvent) 
{
	wv+=10.0f;
	if((wv<360.0f)&&(isWalking))
	{
		ex=80.0f*(GLfloat)cos(GtR*wv);
		ey=80.0f*(GLfloat)sin(GtR*wv);
		RedrawWindow();
		SetTimer(1,100,NULL);
	}
	else
	{
		isWalking=FALSE;
		KillTimer(1);
	}
	CView::OnTimer(nIDEvent);
}

void CStdView::OnHandlingTaklys() 
{
	wglMakeCurrent(m_hDC,m_hRC);
	if(glIsEnabled(GL_LIGHT0))
		glDisable(GL_LIGHT0);
	else
		glEnable(GL_LIGHT0);
	wglMakeCurrent(0,0);
	RedrawWindow();
}

void CStdView::OnUpdateHandlingTaklys(CCmdUI* pCmdUI) 
{ 
	wglMakeCurrent(m_hDC,m_hRC);
	pCmdUI->SetCheck(glIsEnabled(GL_LIGHT0));
	wglMakeCurrent(0,0);
}

void CStdView::OnHandlingLys1() 
{
	wglMakeCurrent(m_hDC,m_hRC);
	if(glIsEnabled(GL_LIGHT1))
		glDisable(GL_LIGHT1);
	else
		glEnable(GL_LIGHT1);
	wglMakeCurrent(0,0);
	RedrawWindow();
}

void CStdView::OnHandlingLys2() 
{
	wglMakeCurrent(m_hDC,m_hRC);
	if(glIsEnabled(GL_LIGHT2))
		glDisable(GL_LIGHT2);
	else
		glEnable(GL_LIGHT2);
	wglMakeCurrent(0,0);
	RedrawWindow();
}

void CStdView::OnUpdateHandlingLys1(CCmdUI* pCmdUI) 
{ 
	wglMakeCurrent(m_hDC,m_hRC);
	pCmdUI->SetCheck(glIsEnabled(GL_LIGHT1));
	wglMakeCurrent(0,0);
}

void CStdView::OnUpdateHandlingLys2(CCmdUI* pCmdUI) 
{ 
	wglMakeCurrent(m_hDC,m_hRC);
	pCmdUI->SetCheck(glIsEnabled(GL_LIGHT2));
	wglMakeCurrent(0,0);
}

void CStdView::OnHandlingGjester() 
{
	CGuests G;
	G.m_guests=guests;
	if(G.DoModal()==IDOK)
	{
		guests=G.m_guests;
		RedrawWindow();
	}
}

int CStdView::PickLight(int x,int y)
{
	// called when mousedown to identify a piece if any
	wglMakeCurrent(m_hDC,m_hRC);
	GLuint selectBuf[BUFSIZE];
	GLint hits;
	GLint viewport[4];

	glGetIntegerv(GL_VIEWPORT,viewport);
	glSelectBuffer(BUFSIZE,selectBuf);
	glRenderMode(GL_SELECT);

	glInitNames();
	glPushName(99); // to be replaced, -1 dont work to well

	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();

	gluPickMatrix(	(GLdouble)x,
					(GLdouble)(viewport[3]-y),
					5.0f,5.0f,
					viewport);

	// same view as normal, see OnSize
	CRect R;
	GetClientRect(&R);
	int cx=R.Width();
	int cy=R.Height();
	gluPerspective(70.0f, (GLdouble)cx/cy, 0.1f, 200.0f);

	glMatrixMode(GL_MODELVIEW);

	m_DrawMode=GL_SELECT;
	DrawScene();
	m_DrawMode=GL_RENDER;

	glMatrixMode(GL_PROJECTION);


	glPopMatrix();
	
	hits=glRenderMode(GL_RENDER);
	
	// process the hits
	if(hits >0)
	{
		return selectBuf[hits*4-1];  
	}
	else
		return -1;
	wglMakeCurrent(0,0);
}

void CStdView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	int theLight=PickLight(point.x,point.y); 
	wglMakeCurrent(m_hDC,m_hRC);
	switch(theLight)
	{
	case 1:
		if(glIsEnabled(GL_LIGHT1))
			glDisable(GL_LIGHT1);
		else
			glEnable(GL_LIGHT1);
		break;
	case 2:
		if(glIsEnabled(GL_LIGHT2))
			glDisable(GL_LIGHT2);
		else
			glEnable(GL_LIGHT2);
		break;

	}
	wglMakeCurrent(0,0);
	RedrawWindow();
	CView::OnRButtonDown(nFlags, point);
}

void CStdView::OnHandlingSethome() 
{
	m_Vz=0.0f;
	m_Vx=0.0f;
	m_Vy=0.0f;
	ex=80.0f;
	ey=80.0f;
	ez=20.0f;
	isWalking=FALSE;
	RedrawWindow();
}
